	.MODEL	LARGE,C
	.CODE
;
psp0	dd	0		; Packet driver ss:sp
rcvr0	dd	0		; C receiver()
stck0	dd	0		; stack for receiver()
cds0	dw	0		; ds for C receiver()
id0	dw	0
es0	dw	0
ds0	dw	0
ax0	dw	0
bx0	dw	0
cx0	dw	0
dx0	dw	0
bp0	dw	0
si0	dw	0
di0	dw	0
;
psp1	dd	0		; Packet driver ss:sp
rcvr1	dd	0		; C receiver()
stck1	dd	0		; stack for receiver()
cds1	dw	0		; ds for C receiver()
id1	dw	1
es1	dw	0
ds1	dw	0
ax1	dw	0
bx1	dw	0
cx1	dw	0
dx1	dw	0
bp1	dw	0
si1	dw	0
di1	dw	0
;
psp2	dd	0		; Packet driver ss:sp
rcvr2	dd	0		; C receiver()
stck2	dd	0		; stack for receiver()
cds2	dw	0		; ds for C receiver()
id2	dw	2
es2	dw	0
ds2	dw	0
ax2	dw	0
bx2	dw	0
cx2	dw	0
dx2	dw	0
bp2	dw	0
si2	dw	0
di2	dw	0
;
psp3	dd	0		; Packet driver ss:sp
rcvr3	dd	0		; C receiver()
stck3	dd	0		; stack for receiver()
cds3	dw	0		; ds for C receiver()
id3	dw	3
es3	dw	0
ds3	dw	0
ax3	dw	0
bx3	dw	0
cx3	dw	0
dx3	dw	0
bp3	dw	0
si3	dw	0
di3	dw	0
;
; void far pkset (int portno, 
;	void (far *receiver)(unsigned short far *p), int far *stk, int dseg);
;	receiver: C receiver function address
;	stk:	  top (NOT start) of stack address
;
	public	pkset
pkset	label	far
portno	EQU	WORD PTR[BP+6]
coff	EQU	WORD PTR[BP+8]
cseg	EQU	WORD PTR[BP+10]
soff	EQU	WORD PTR[BP+12]
sseg	EQU	WORD PTR[BP+14]
cdseg	EQU	WORD PTR[BP+16]
;
	push	bp
	mov	bp,sp
;
	mov	ax,portno
	cmp	ax,0
	je	set0
	cmp	ax,1
	je	set1
	cmp	ax,2
	je	set2
	cmp	ax,3
	je	set3
	jmp	setret
;
set0:
	mov	ax,coff				; receiver address
	mov	word ptr cs:rcvr0,ax
	mov	ax,cseg
	mov	word ptr cs:rcvr0+2,ax
	mov	ax,soff				; stack address
	mov	word ptr cs:stck0,ax
	mov	ax,sseg
	mov	word ptr cs:stck0+2,ax
	mov	ax,cdseg
	mov	word ptr cs:cds0,ax
	jmp	SHORT setret
;
set1:
	mov	ax,coff				; receiver address
	mov	word ptr cs:rcvr1,ax
	mov	ax,cseg
	mov	word ptr cs:rcvr1+2,ax
	mov	ax,soff				; stack address
	mov	word ptr cs:stck1,ax
	mov	ax,sseg
	mov	word ptr cs:stck1+2,ax
	mov	ax,cdseg
	mov	word ptr cs:cds1,ax
	jmp	SHORT setret
;
set2:
	mov	ax,coff				; receiver address
	mov	word ptr cs:rcvr2,ax
	mov	ax,cseg
	mov	word ptr cs:rcvr2+2,ax
	mov	ax,soff				; stack address
	mov	word ptr cs:stck2,ax
	mov	ax,sseg
	mov	word ptr cs:stck2+2,ax
	mov	ax,cdseg
	mov	word ptr cs:cds2,ax
	jmp	SHORT setret
;
set3:
	mov	ax,coff				; receiver address
	mov	word ptr cs:rcvr3,ax
	mov	ax,cseg
	mov	word ptr cs:rcvr3+2,ax
	mov	ax,soff				; stack address
	mov	word ptr cs:stck3,ax
	mov	ax,sseg
	mov	word ptr cs:stck3+2,ax
	mov	ax,cdseg
	mov	word ptr cs:cds3,ax
	jmp	SHORT setret
;
setret:
	mov	sp,bp
	pop	bp
	retf
;
; pkint0/1/2/3 - Packet driver receive call handlers
;
	public	pkint0
pkint0	label	far
	pushf					; save PD interrupt state
	cli					; no distractions
	mov	word ptr cs:psp0,sp		; save my stack
	mov	word ptr cs:psp0+2,ss
	mov	sp,word ptr cs:stck0		; load C stack
	mov	ss,word ptr cs:stck0+2
;
	mov	cs:es0,es			; save parms block
	mov	cs:ds0,ds
	mov	cs:ax0,ax
	mov	cs:bx0,bx
	mov	cs:cx0,cx
	mov	cs:dx0,dx
	mov	cs:bp0,bp
	mov	cs:si0,si
	mov	cs:di0,di
	push	cs				; push parms block base
	mov	ax,OFFSET id0			; push parms block offset
	push	ax
;
	mov	ds,cs:cds0			; load C ds
	call	cs:[rcvr0]
;
	mov	es,cs:es0			; restore parms block
	mov	ds,cs:ds0
	mov	ax,cs:ax0
	mov	bx,cs:bx0
	mov	cx,cs:cx0
	mov	dx,cs:dx0
	mov	bp,cs:bp0
	mov	si,cs:si0
	mov	di,cs:di0
;
	mov	sp,word ptr cs:psp0		; restore my stack
	mov	ss,word ptr cs:psp0+2
	popf
	retf
;
	public	pkint1
pkint1	label	far
	pushf					; save PD interrupt state
	cli					; no distractions
	mov	word ptr cs:psp1,sp		; save my stack
	mov	word ptr cs:psp1+2,ss
	mov	sp,word ptr cs:stck1		; load C stack
	mov	ss,word ptr cs:stck1+2
;
	mov	cs:es1,es			; save parms block
	mov	cs:ds1,ds
	mov	cs:ax1,ax
	mov	cs:bx1,bx
	mov	cs:cx1,cx
	mov	cs:dx1,dx
	mov	cs:bp1,bp
	mov	cs:si1,si
	mov	cs:di1,di
	push	cs				; push parms block base
	mov	ax,OFFSET id1			; push parms block offset
	push	ax
;
	mov	ds,cs:cds1			; load C ds
	call	cs:[rcvr1]
;
	mov	es,cs:es1			; restore parms block
	mov	ds,cs:ds1
	mov	ax,cs:ax1
	mov	bx,cs:bx1
	mov	cx,cs:cx1
	mov	dx,cs:dx1
	mov	bp,cs:bp1
	mov	si,cs:si1
	mov	di,cs:di1
;
	mov	sp,word ptr cs:psp1		; restore my stack
	mov	ss,word ptr cs:psp1+2
	popf
	retf
;
	public	pkint2
pkint2	label	far
	pushf					; save PD interrupt state
	cli					; no distractions
	mov	word ptr cs:psp2,sp		; save my stack
	mov	word ptr cs:psp2+2,ss
	mov	sp,word ptr cs:stck2		; load C stack
	mov	ss,word ptr cs:stck2+2
;
	mov	cs:es2,es			; save parms block
	mov	cs:ds2,ds
	mov	cs:ax2,ax
	mov	cs:bx2,bx
	mov	cs:cx2,cx
	mov	cs:dx2,dx
	mov	cs:bp2,bp
	mov	cs:si2,si
	mov	cs:di2,di
	push	cs				; push parms block base
	mov	ax,OFFSET id2			; push parms block offset
	push	ax
;
	mov	ds,cs:cds2			; load C ds
	call	cs:[rcvr2]
;
	mov	es,cs:es2			; restore parms block
	mov	ds,cs:ds2
	mov	ax,cs:ax2
	mov	bx,cs:bx2
	mov	cx,cs:cx2
	mov	dx,cs:dx2
	mov	bp,cs:bp2
	mov	si,cs:si2
	mov	di,cs:di2
;
	mov	sp,word ptr cs:psp2		; restore my stack
	mov	ss,word ptr cs:psp2+2
	popf
	retf
;
	public	pkint3
pkint3	label	far
	pushf					; save PD interrupt state
	cli					; no distractions
	mov	word ptr cs:psp3,sp		; save my stack
	mov	word ptr cs:psp3+2,ss
	mov	sp,word ptr cs:stck3		; load C stack
	mov	ss,word ptr cs:stck3+2

;
	mov	cs:es3,es			; save parms block
	mov	cs:ds3,ds
	mov	cs:ax3,ax
	mov	cs:bx3,bx
	mov	cs:cx3,cx
	mov	cs:dx3,dx
	mov	cs:bp3,bp
	mov	cs:si3,si
	mov	cs:di3,di
	push	cs				; push parms block base
	mov	ax,OFFSET id3			; push parms block offset
	push	ax
;
	mov	ds,cs:cds3			; load C ds
	call	cs:[rcvr3]
;
	mov	es,cs:es3			; restore parms block
	mov	ds,cs:ds3
	mov	ax,cs:ax3
	mov	bx,cs:bx3
	mov	cx,cs:cx3
	mov	dx,cs:dx3
	mov	bp,cs:bp3
	mov	si,cs:si3
	mov	di,cs:di3
;
	mov	sp,word ptr cs:psp3		; restore my stack
	mov	ss,word ptr cs:psp3+2
	popf
	retf
;
; pksende - Packet driver as_send_pkt() upcall (ETHERNET)
;
;buffer available upcall:
;	(*upcall)(buffer, result)
;		int	result;         AX	/* 0 for copy ok */
;		char far *buffer;	ES:DI	/* from as_send_pkt() call */
;
	public	pksende
pksende	label	far
;
	cmp	ax,0
	jz	pksende1
	mov	byte ptr es:[di+16],0ffH	; mark packet as 'send fail'
	jmp	short pksende2
pksende1:
	mov	byte ptr es:[di+16],000H	; mark packet as 'send ok'
pksende2:
;
	retf
;
;
;
; pksends - Packet driver as_send_pkt() upcall (SLIP)
;
;buffer available upcall:
;	(*upcall)(buffer, result)
;		int	result;         AX	/* 0 for copy ok */
;		char far *buffer;	ES:DI	/* from as_send_pkt() call */
;
	public	pksends
pksends	label	far
;
	cmp	ax,0
	jz	pksends1
	mov	byte ptr es:[di],0ffH		; mark packet as 'send fail'
	jmp	short pksends2
pksends1:
	mov	byte ptr es:[di],000H		; mark packet as 'send ok'
pksends2:
;
	retf
;
	end
