CRTC	EQU	3D4h			; Port of CRTC registers

wrinx	MACRO	port, index, val
	mov	al,index		;; Write 'port' index 'index' with 'val'
	mov	ah,val
	mov	dx,port
	out	dx,ax
ENDM

modinx	MACRO	port, index, mask, nvw
	mov	dx,port
	mov	al,index
	out	dx,al
	inc	dx
	in	al,dx			;; Read the old value
	and	al,not mask		;; Mask out bits to be changed
	or	al,nvw			;; Or in the changed bits
	out	dx,al			;; Write the value back again
ENDM

outp	MACRO	port, value
	mov	dx,port			;; Write a byte to port 'port'
	mov	al,value
	out	dx,al
ENDM
